package org.zeroturnaround.javarebel.wicket;

import org.zeroturnaround.javarebel.ClassResourceSource;
import org.zeroturnaround.javarebel.IntegrationFactory;
import org.zeroturnaround.javarebel.Plugin;

public class WicketPlugin implements Plugin {

	public void preinit() {		
		ClassLoader cl = WicketPlugin.class.getClassLoader();

		IntegrationFactory.getInstance().addIntegrationProcessor(cl,
				new String[] { "org.apache.wicket.injection.Injector", },
				new InjectorCBP());

		IntegrationFactory
				.getInstance()
				.addIntegrationProcessor(
						cl,
						new String[] { "org.apache.wicket.injection.web.InjectorHolder", },
						new InjectorHolderCBP());
		
		
		IntegrationFactory
		.getInstance()
		.addIntegrationProcessor(
				cl,
				new String[] { "org.apache.wicket.spring.SpringBeanLocator", },
				new SpringBeanLocatorCBP());

	}

	public boolean checkDependencies(ClassLoader cl, ClassResourceSource crs) {
		return crs.getClassResource("org.apache.wicket.injection.Injector") != null;
	}

  public String getAuthor() {
    return null;
  }

  public String getDescription() {
    return "Reinjects @SpringBean dependencies.";
  }

  public String getId() {
    return "wicket_plugin";
  }

  public String getName() {
    return "Wicket Plugin";
  }

  public String getWebsite() {
    return null;
  }

}
